/*
 * Heir.java
 *
 * Created on 2007. majus 23., 13:32
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Successio;
import java.util.List;
import java.util.Vector;

/**
 * Orokos osztaly, a Szemely osztalybol szarmaztatva
 * @author Tar Peter
 */
public class Heir extends Person{
    
    private boolean undeserved=false; //Erdemtelen
    private boolean renounced=false; //Lemondott
    private boolean illegal=false; //Torveny tiltja
    private boolean refused=false; //Visszautasitotta
    private boolean denied=false; //Kitagadtak
    private boolean renouncedAll=false; //Leszarmazoira vonatkozolag lemondott
    private Vector<Property> properties;  //Az osztalyra bocsatott vagyonok tombje
    private double assets = 1.0; // Megmondja, hogy az illeto mennyit orokol
    private boolean done = false; // Valtozo, ami jelzi, hogy meg szamitasba kell-e venni a tovabbi szamitasoknal...
    private double propSum = 0.0; // Az osztalyra bocsatott vagyonainak az osszege
   
    /** Creates a new instance of Heir */
    public Heir (String nev, String id){
        super(nev, id);
        properties=new Vector();
    }
    
    //Get, Set, Is fuggvenyek:
    public boolean isIllegal() {
        return illegal;
    }

    public void setIllegal(boolean illegal) {
        this.illegal = illegal;
    }

    public boolean isRenounced() {
        return renounced;
    }

    public void setRenounced(boolean renounced) {
        this.renounced = renounced;
    }

    public boolean isUndeserved() {
        return undeserved;
    }

    public void setUndeserved(boolean undeserved) {
        this.undeserved = undeserved;
    }    
    
    public boolean isRefused() {
        return refused;
    }
    
    public void setRefused(boolean refused) {
        this.refused=refused;
    }
    
    public boolean isRenouncedAll() {
        return renouncedAll;
    }
    
    public void setRenouncedAll(boolean renouncedAll) {
        this.renouncedAll=renouncedAll;
    }
    
    public boolean isDenied() {
        return denied;
    }
    
    public void setDenied(boolean denied) {
        this.denied=denied;
    }
    
    public void addProperty(Property prop){
        properties.add(prop);
    }
    
    public Vector<Property> getProperties(){
        return this.properties;
    }

    //Megmondja, hogy az illeo orokolhet-e
    public boolean canInherit()
    {
        return (!dead&&!undeserved&&!renounced&&!illegal&&!denied&&!renouncedAll&&!refused);
    }
    
    public void setAssets(double assets)
    {
        this.assets = assets;
    }
    
    public double getAssets()
    {
        return this.assets;
    }
    
    public boolean isDone()
    {
        return this.done;
    }
    
    public void setDone(boolean b)
    {
        this.done = b;
    }
    
    public Heir[] getChildren(){
        //if(this.children.size()!=0)
             return this.children.toArray(new Heir[0]);
        //else
          //  return new Heir[0];
    }
    
    public String getInherit()
    {
        return this.inherit;
    }
    
    public void setInherit()
    {
        if(this.isDead())
            this.inherit = "Halott";
        if(this.isIllegal())
        {
            if(this.inherit.equals(""))
                this.inherit = "T\u00F6rv\u00E9ny tiltja";
            else
                this.inherit = this.inherit.concat(", T\u00F6rv\u00E9ny tiltja");
        }
        if(this.isRenounced())
        {
            if(this.inherit.equals(""))
                this.inherit = "Lemondott";
            else
                this.inherit = this.inherit.concat(", Lemondott");
        }
        if(this.isRenouncedAll())
        {
            if(this.inherit.equals(""))
                this.inherit = "Lemondott a leszrmazira vonatkozan";
            else 
                this.inherit = this.inherit.concat("Lemondott a leszrmazira vonatkozan");
        }
        if(this.isUndeserved())
        {
            if(this.inherit.equals(""))
                this.inherit = "\u00C9rdemtelen";
            else
                this.inherit = this.inherit.concat(", \u00C9rdemtelen");
        }
        if(this.isRefused())
        {
            if(this.inherit.equals(""))
                this.inherit = "Visszautastotta";
            else
                this.inherit = this.inherit.concat(", Visszautastotta");
        }
        if(this.isDenied())
        {
            if(this.inherit.equals(""))
                this.inherit = "Kitagadtk";
            else
                this.inherit = this.inherit.concat(", Kitagadtk");
        }
        
    }
    
    public void setWifeInherit(String inherit){
        this.inherit = inherit;
    }
    
    public void setPropSum(double prop)
    {
        this.propSum += prop;
    }
    
    public double getPropSum()
    {
        return this.propSum;
    }
    
    
}
