/*
 * LegatorForm.java
 *
 * Created on 2007. majus 23., 13:23
 */

package Successio;

import java.awt.Panel;

/**
 * Orokos bekeresere szolgalo form
 * @author  Tar Peter
 */
public class HeirForm extends javax.swing.JFrame {
    
    private ChildrenPanel cp; 
    private PropertyPanel pp; 
    private Sch scheduler; //Az utemezot megkapja parameterkent
    private String id,choose;
    
    /**
     * Creates new form LegatorForm
     */
    public HeirForm(){}
    public HeirForm(Sch scheduler,String id, String choose) {
        initComponents();
        this.id = id;
        this.choose=choose;
        this.scheduler=scheduler;
        this.setSize(700,500);
        cp=new ChildrenPanel(scheduler);
        Panel.addTab("Gyerekek",cp);
        
        if (choose.toString().equals("heir")){
            pp=new PropertyPanel(scheduler);
            Panel.addTab("Oszt\u00E1lyra bocs\u00E1t\u00E1s",pp);
            Panel.setEnabledAt(0,false);
            Panel.setEnabledAt(1,false);
            cp.setAllEnabled(false);
            pp.setAllEnabled(false);
            Next.setEnabled(false);
            setLegatorLabel();
        }
        if (choose.toString().equals("lineageheir")){
            Panel.setEnabledAt(0,false);
            cp.setAllEnabled(false);
            pp=new PropertyPanel(scheduler);
            Next.setEnabled(false);
        }
        this.setVisible(true);
        NameLabel.setText(scheduler.getModel().getHeir(id).getName());
        
        
    }
    
    private void setLegatorLabel(){
        String legator="";
        Person someone=scheduler.getModel().getHeir(id);
        while(someone.hasParent()){
            legator=someone.getParent().getName().concat(" --> ").concat(legator);
            someone=someone.getParent();
        }
        LegatorLabel.setText(legator);
    }
    private void setVisibility(){
        DeniedCheckBox.setVisible(false);
        RefusedCheckBox.setVisible(false);
        RenouncedAllCheckBox.setVisible(false);
        UndeservedCheckBox.setVisible(false);
        RenouncedCheckBox.setVisible(false);
        IllegalCheckBox.setVisible(false);
        DeadCheckBox.setVisible(false);
        Commit.setVisible(false);
        HeirFormLabel2.setVisible(false);
        HeirFormSeparator1.setVisible(false);
        HeirFormSeparator2.setVisible(false);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        HeirFormLabel1 = new javax.swing.JLabel();
        NameLabel = new javax.swing.JLabel();
        Commit = new javax.swing.JButton();
        Next = new javax.swing.JButton();
        Panel = new javax.swing.JTabbedPane();
        HeirFormSeparator1 = new javax.swing.JSeparator();
        HeirFormSeparator2 = new javax.swing.JSeparator();
        DeadCheckBox = new javax.swing.JCheckBox();
        UndeservedCheckBox = new javax.swing.JCheckBox();
        RenouncedCheckBox = new javax.swing.JCheckBox();
        IllegalCheckBox = new javax.swing.JCheckBox();
        RefusedCheckBox = new javax.swing.JCheckBox();
        DeniedCheckBox = new javax.swing.JCheckBox();
        RenouncedAllCheckBox = new javax.swing.JCheckBox();
        HeirFormLabel2 = new javax.swing.JLabel();
        LegatorLabel = new javax.swing.JLabel();

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("\u00d6r\u00f6k\u00f6s adatlapja");
        setResizable(false);
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                formMouseClicked(evt);
            }
        });

        HeirFormLabel1.setText("Az \u00f6r\u00f6k\u00f6s neve:");
        HeirFormLabel1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                HeirFormLabel1MouseClicked(evt);
            }
        });

        Commit.setText("J\u00f3v\u00e1hagy\u00e1s");
        Commit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CommitActionPerformed(evt);
            }
        });

        Next.setText("Tov\u00e1bb");
        Next.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                NextActionPerformed(evt);
            }
        });

        DeadCheckBox.setText("Halott");
        DeadCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        DeadCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        DeadCheckBox.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                DeadCheckBoxMouseClicked(evt);
            }
        });
        DeadCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DeadCheckBoxActionPerformed(evt);
            }
        });

        UndeservedCheckBox.setText("\u00c9rdemtelen");
        UndeservedCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        UndeservedCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        UndeservedCheckBox.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                UndeservedCheckBoxMouseClicked(evt);
            }
        });
        UndeservedCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                UndeservedCheckBoxActionPerformed(evt);
            }
        });

        RenouncedCheckBox.setText("Lemondott");
        RenouncedCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        RenouncedCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        RenouncedCheckBox.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                RenouncedCheckBoxMouseClicked(evt);
            }
        });
        RenouncedCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RenouncedCheckBoxActionPerformed(evt);
            }
        });

        IllegalCheckBox.setText("T\u00f6rv\u00e9ny tiltja");
        IllegalCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        IllegalCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        IllegalCheckBox.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                IllegalCheckBoxMouseClicked(evt);
            }
        });
        IllegalCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                IllegalCheckBoxActionPerformed(evt);
            }
        });

        RefusedCheckBox.setText("Visszautas\u00edtotta");
        RefusedCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        RefusedCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        RefusedCheckBox.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                RefusedCheckBoxMouseClicked(evt);
            }
        });
        RefusedCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RefusedCheckBoxActionPerformed(evt);
            }
        });

        DeniedCheckBox.setText("Kitagadt\u00e1k");
        DeniedCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        DeniedCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        DeniedCheckBox.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                DeniedCheckBoxMouseClicked(evt);
            }
        });
        DeniedCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DeniedCheckBoxActionPerformed(evt);
            }
        });

        RenouncedAllCheckBox.setText("Lesz\u00e1rmaz\u00f3ira vonatkoz\u00f3an lemondott");
        RenouncedAllCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        RenouncedAllCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        RenouncedAllCheckBox.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                RenouncedAllCheckBoxMouseClicked(evt);
            }
        });
        RenouncedAllCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RenouncedAllCheckBoxActionPerformed(evt);
            }
        });

        HeirFormLabel2.setText("Az \u00f6r\u00f6k\u00f6s kapcsolata az \u00f6r\u00f6khagy\u00f3val:");
        HeirFormLabel2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                HeirFormLabel2MouseClicked(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(Panel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 653, Short.MAX_VALUE)
                    .addComponent(Next)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addComponent(HeirFormLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(LegatorLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 460, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(HeirFormSeparator2, javax.swing.GroupLayout.DEFAULT_SIZE, 653, Short.MAX_VALUE)
                            .addComponent(HeirFormSeparator1, javax.swing.GroupLayout.DEFAULT_SIZE, 653, Short.MAX_VALUE)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(DeadCheckBox)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(IllegalCheckBox)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(RenouncedCheckBox)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(RenouncedAllCheckBox))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(RefusedCheckBox)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(DeniedCheckBox)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(UndeservedCheckBox)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 317, Short.MAX_VALUE)
                                .addComponent(Commit))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(HeirFormLabel1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(NameLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 569, Short.MAX_VALUE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(LegatorLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(HeirFormLabel2))
                .addGap(8, 8, 8)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(NameLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(HeirFormLabel1))
                .addGap(8, 8, 8)
                .addComponent(HeirFormSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(DeadCheckBox)
                    .addComponent(IllegalCheckBox)
                    .addComponent(RenouncedCheckBox)
                    .addComponent(RenouncedAllCheckBox))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(RefusedCheckBox)
                    .addComponent(DeniedCheckBox)
                    .addComponent(UndeservedCheckBox)
                    .addComponent(Commit))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(HeirFormSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(Panel, javax.swing.GroupLayout.DEFAULT_SIZE, 245, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(Next)
                .addContainerGap())
        );
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-681)/2, (screenSize.height-440)/2, 681, 440);
    }// </editor-fold>//GEN-END:initComponents

private void UndeservedCheckBoxMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_UndeservedCheckBoxMouseClicked
    // TODO add your handling code here:
    String [] keys={"Kiess","rdemtelensg"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_UndeservedCheckBoxMouseClicked

private void DeniedCheckBoxMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_DeniedCheckBoxMouseClicked
    // TODO add your handling code here:
    String [] keys={"Kiess"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_DeniedCheckBoxMouseClicked

private void RefusedCheckBoxMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_RefusedCheckBoxMouseClicked
    // TODO add your handling code here:
    String [] keys={"Visszautass", "Kiess"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_RefusedCheckBoxMouseClicked

private void RenouncedAllCheckBoxMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_RenouncedAllCheckBoxMouseClicked
    // TODO add your handling code here:
    String [] keys={"Lemonds", "Kiess"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_RenouncedAllCheckBoxMouseClicked

private void RenouncedCheckBoxMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_RenouncedCheckBoxMouseClicked
    // TODO add your handling code here:
    String [] keys={"Lemonds","Kiess"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_RenouncedCheckBoxMouseClicked

private void IllegalCheckBoxMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_IllegalCheckBoxMouseClicked
    // TODO add your handling code here:
    String [] keys={"Kiess"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_IllegalCheckBoxMouseClicked

private void DeadCheckBoxMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_DeadCheckBoxMouseClicked
    // TODO add your handling code here:
    String [] keys={"Kiess"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_DeadCheckBoxMouseClicked

private void HeirFormLabel1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_HeirFormLabel1MouseClicked
    // TODO add your handling code here:
    String [] keys={"rks"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_HeirFormLabel1MouseClicked

private void HeirFormLabel2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_HeirFormLabel2MouseClicked
    // TODO add your handling code here:
    String [] keys={"rks", "rkhagy"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_HeirFormLabel2MouseClicked

private void formMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseClicked
    // TODO add your handling code here:
    String [] keys={"rkls"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_formMouseClicked

    private void DeniedCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DeniedCheckBoxActionPerformed
    //Atallitja az undeserved valtozot, ha szukseges
    scheduler.getModel().getHeir(this.id).setDenied(DeniedCheckBox.isSelected());
   
    }//GEN-LAST:event_DeniedCheckBoxActionPerformed

    private void RefusedCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RefusedCheckBoxActionPerformed
    //Atallitja az undeserved valtozot, ha szukseges
    scheduler.getModel().getHeir(this.id).setRefused(RefusedCheckBox.isSelected());
    }//GEN-LAST:event_RefusedCheckBoxActionPerformed

    private void RenouncedAllCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RenouncedAllCheckBoxActionPerformed
    //Atallitja az undeserved valtozot, ha szukseges
    scheduler.getModel().getHeir(this.id).setRenouncedAll(RenouncedAllCheckBox.isSelected());
    }//GEN-LAST:event_RenouncedAllCheckBoxActionPerformed

    private void UndeservedCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_UndeservedCheckBoxActionPerformed
    //Atallitja az undeserved valtozot, ha szukseges
    scheduler.getModel().getHeir(this.id).setUndeserved(UndeservedCheckBox.isSelected());
    }//GEN-LAST:event_UndeservedCheckBoxActionPerformed

    private void RenouncedCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RenouncedCheckBoxActionPerformed
    //Atallitja a renounced valtozot, ha szukseges
    scheduler.getModel().getHeir(this.id).setRenounced(RenouncedCheckBox.isSelected());
    }//GEN-LAST:event_RenouncedCheckBoxActionPerformed

    private void IllegalCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_IllegalCheckBoxActionPerformed
    //Atallitja az illegal valtozot, ha szukseges
    scheduler.getModel().getHeir(this.id).setIllegal(IllegalCheckBox.isSelected());
    }//GEN-LAST:event_IllegalCheckBoxActionPerformed

    private void DeadCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DeadCheckBoxActionPerformed
    //Atallitja a halott valtozot, ha szuksegefs
    scheduler.getModel().getHeir(this.id).setDead(DeadCheckBox.isSelected());
    }//GEN-LAST:event_DeadCheckBoxActionPerformed

    private void CommitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CommitActionPerformed
    //Ha az orokos orokolhet, engedelyezi az osztalyra bocsatott vagyonok bekereset
    if(RenouncedAllCheckBox.isSelected()){
        NextActionPerformed(evt);
    }
    else{
        if (choose.toString().equals("heir")){
            if(scheduler.getModel().getHeir(this.id).canInherit()  ){
                pp.setAllEnabled(true);
                Panel.setEnabledAt(1,true);
                Panel.setSelectedIndex(1);
                Next.setEnabled(true);
                DeadCheckBox.setEnabled(false);
                UndeservedCheckBox.setEnabled(false);
                RenouncedCheckBox.setEnabled(false);
                IllegalCheckBox.setEnabled(false);
                RenouncedAllCheckBox.setEnabled(false);
                DeniedCheckBox.setEnabled(false);
                RefusedCheckBox.setEnabled(false);
                Commit.setEnabled(false);
        }
        //Ha nem orokolhet, akkor engedelyezi a gyerekek bekereset
            else{
                cp.setAllEnabled(true);
                Panel.setEnabledAt(0,true);
                Panel.setSelectedIndex(0);
                Next.setEnabled(true);
                DeadCheckBox.setEnabled(false);
                UndeservedCheckBox.setEnabled(false);
                RenouncedCheckBox.setEnabled(false);
                IllegalCheckBox.setEnabled(false);
                RenouncedAllCheckBox.setEnabled(false);
                DeniedCheckBox.setEnabled(false);
                RefusedCheckBox.setEnabled(false);
                Commit.setEnabled(false);
            }
        }
        if (choose.toString().equals("lineageheir")){
            if(scheduler.getModel().getHeir(this.id).canInherit()  ){
                Next.setEnabled(true);
                DeadCheckBox.setEnabled(false);
                UndeservedCheckBox.setEnabled(false);
                RenouncedCheckBox.setEnabled(false);
                IllegalCheckBox.setEnabled(false);
                RenouncedAllCheckBox.setEnabled(false);
                DeniedCheckBox.setEnabled(false);
                RefusedCheckBox.setEnabled(false);
                Commit.setEnabled(false);
        }
        //Ha nem orokolhet, akkor engedelyezi a gyerekek bekereset
            else{
                cp.setAllEnabled(true);
                Panel.setEnabledAt(0,true);
                Panel.setSelectedIndex(0);
                Next.setEnabled(true);
                DeadCheckBox.setEnabled(false);
                UndeservedCheckBox.setEnabled(false);
                RenouncedCheckBox.setEnabled(false);
                IllegalCheckBox.setEnabled(false);
                RenouncedAllCheckBox.setEnabled(false);
                DeniedCheckBox.setEnabled(false);
                RefusedCheckBox.setEnabled(false);
                Commit.setEnabled(false);
            }
        }
    }
    }//GEN-LAST:event_CommitActionPerformed

    private void NextActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NextActionPerformed
    //Bezarja az ablakot, es visszaadja a vezerlest az utemezonek
   
        scheduler.setHeir(pp.getProperties(),cp.getNames());
        if (choose.equals("heir")){
            scheduler.windowClosed();
        }
        else scheduler.windowClosed2();
    this.dispose();
    }//GEN-LAST:event_NextActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new LegatorForm().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Commit;
    private javax.swing.JCheckBox DeadCheckBox;
    private javax.swing.JCheckBox DeniedCheckBox;
    private javax.swing.JLabel HeirFormLabel1;
    private javax.swing.JLabel HeirFormLabel2;
    private javax.swing.JSeparator HeirFormSeparator1;
    private javax.swing.JSeparator HeirFormSeparator2;
    private javax.swing.JCheckBox IllegalCheckBox;
    private javax.swing.JLabel LegatorLabel;
    private javax.swing.JLabel NameLabel;
    private javax.swing.JButton Next;
    private javax.swing.JTabbedPane Panel;
    private javax.swing.JCheckBox RefusedCheckBox;
    private javax.swing.JCheckBox RenouncedAllCheckBox;
    private javax.swing.JCheckBox RenouncedCheckBox;
    private javax.swing.JCheckBox UndeservedCheckBox;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
    
}
