/*
 * LegatorForm.java
 *
 * Created on 2007. majus 23., 13:23
 */

package Successio;

import java.awt.Panel;

/**
 * Orokhagyo bekeresere szolgalo form
 * @author  Tar Peter
 */
public class LegatorForm extends javax.swing.JFrame {
    
    private ChildrenPanel cp;
    private WifePanel wp;
    private LineagePropertyPanel lp;
    private MotherLineagePanel mp;
    private FatherLineagePanel fp;
    private Sch scheduler; //Az utemezot megkapja parameterkent
    private boolean choose; //eldonti h melyik panelekkel jelenik meg a legatorform
    
    /**
     * Creates new form LegatorForm
     */
    public LegatorForm(){}
    public LegatorForm(Sch scheduler, boolean first) {
        initComponents();
        this.scheduler=scheduler;
        this.setSize(700,500);
        choose=first;
        if (first==true){
        cp=new ChildrenPanel(scheduler);
        Panel.addTab("Az \u00F6r\u00F6khagy\u00F3 gyerekei",cp);
        wp=new WifePanel(scheduler);
        Panel.addTab("Az \u00F6r\u00F6khagy\u00F3 hzastrsa",wp);
        cp.setAllEnabled(false);
        wp.setAllEnabled(false);
        Next.setEnabled(false);
        WealthField.setText("0");
        }
        else {
        NameField.setText(scheduler.getModel().getLegator().getName());
        WealthField.setText(Double.toString(scheduler.getModel().getLegator().getWealth()));
        
        mp=new MotherLineagePanel(scheduler);
        Panel.addTab("Anyai felmenk",mp);
        mp.setMotherName("Anya");
        mp.setMfatherName("Anyai nagyapa");
        mp.setMmotherName("Anyai nagyanya");
        fp=new FatherLineagePanel(scheduler);
        Panel.addTab("Apai felmenk",fp);
        fp.setFatherName("Apa");
        fp.setFfatherName("Apai nagyapa");
        fp.setFmotherName("Apai nagyanya");
        
        lp=new LineagePropertyPanel(scheduler);
        Panel.addTab("rklt vagyonok",lp);
        mp.setAllEnabled(true);
        fp.setAllEnabled(true);
        lp.setAllEnabled(true);
        NameField.setEnabled(false);
        WealthField.setEnabled(false);
        Commit.setEnabled(false);
        
        }
        
        this.setVisible(true);
      
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        LegatorFormLabel1 = new javax.swing.JLabel();
        LegatorFormLabel2 = new javax.swing.JLabel();
        NameField = new javax.swing.JTextField();
        WealthField = new javax.swing.JTextField();
        Commit = new javax.swing.JButton();
        Next = new javax.swing.JButton();
        Panel = new javax.swing.JTabbedPane();
        LegatorFormSeparator2 = new javax.swing.JSeparator();

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("\u00d6r\u00f6khagy\u00f3 adatlapja");
        setResizable(false);
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                formMouseClicked(evt);
            }
        });

        LegatorFormLabel1.setText("Az \u00f6r\u00f6khagy\u00f3 neve:");
        LegatorFormLabel1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                LegatorFormLabel1MouseClicked(evt);
            }
        });

        LegatorFormLabel2.setText("Az \u00f6r\u00f6khagy\u00f3 vagyona:");
        LegatorFormLabel2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                LegatorFormLabel2MouseClicked(evt);
            }
        });

        NameField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                NameFieldActionPerformed(evt);
            }
        });

        WealthField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                WealthFieldActionPerformed(evt);
            }
        });

        Commit.setText("J\u00f3v\u00e1hagy\u00e1s");
        Commit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CommitActionPerformed(evt);
            }
        });

        Next.setText("Tov\u00e1bb");
        Next.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                NextActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(LegatorFormSeparator2, javax.swing.GroupLayout.DEFAULT_SIZE, 702, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(Panel, javax.swing.GroupLayout.DEFAULT_SIZE, 627, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(Next))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                .addComponent(LegatorFormLabel1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(NameField, javax.swing.GroupLayout.DEFAULT_SIZE, 504, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(LegatorFormLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(WealthField, javax.swing.GroupLayout.DEFAULT_SIZE, 486, Short.MAX_VALUE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(Commit)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(LegatorFormLabel1)
                    .addComponent(NameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(WealthField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Commit)
                    .addComponent(LegatorFormLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(LegatorFormSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, 2, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(Next)
                    .addComponent(Panel, javax.swing.GroupLayout.DEFAULT_SIZE, 319, Short.MAX_VALUE))
                .addContainerGap())
        );
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-730)/2, (screenSize.height-438)/2, 730, 438);
    }// </editor-fold>//GEN-END:initComponents

private void formMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseClicked
    // TODO add your handling code here:
    String [] keys={"rkls"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_formMouseClicked

private void LegatorFormLabel2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_LegatorFormLabel2MouseClicked
    // TODO add your handling code here:
    String [] keys={"Hagyatk"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_LegatorFormLabel2MouseClicked

private void LegatorFormLabel1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_LegatorFormLabel1MouseClicked
    // TODO add your handling code here:
    String [] keys={"rkhagy"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_LegatorFormLabel1MouseClicked

    private void WealthFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_WealthFieldActionPerformed
    //Meghivja a WealthCommitot
    CommitActionPerformed(evt);
    }//GEN-LAST:event_WealthFieldActionPerformed

    private void NameFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NameFieldActionPerformed
    //Meghivja a NameCommitot
    CommitActionPerformed(evt);
    }//GEN-LAST:event_NameFieldActionPerformed

    private void CommitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CommitActionPerformed
    //Megnezi, hogy helyes adat van-e beirva a vagyon helyere (szam), majd engedelyezi a gyerekek bekereset
    boolean valid=true;
    try{
        int i=Integer.parseInt(WealthField.getText());
    }
    catch(NumberFormatException ex){
        valid=false;
    }
    if(NameField.getText().equals(""))
        valid=false;
    if(valid){
    NameField.setEnabled(false);
    WealthField.setEnabled(false);
    Commit.setEnabled(false);
    if (choose){
    cp.setAllEnabled(true);
    wp.setAllEnabled(true);
    }
    else{
    lp.setAllEnabled(true);
    mp.setAllEnabled(true);
    fp.setAllEnabled(true);
    }
    Next.setEnabled(true);
    }
    }//GEN-LAST:event_CommitActionPerformed

    private void NextActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NextActionPerformed
    //Visszaadja a vezerlest az utemezonek, az orokhagyo adataival, majd bezarja az ablakot
    if (choose){
        if(wp.isPanelValid()){
            scheduler.setLegator(NameField.getText(),Double.parseDouble(WealthField.getText()),cp.getNames());
            scheduler.getModel().getLegator().getWife().setName(wp.getWifeName());
            scheduler.windowClosed();
            this.dispose();
        }
    }
    //ha mar masodszor jelent meg az ablak (a felmenok adataival), akkor ez hajtodik vegre
    else{
        //ha minden mezobe van irva nev
        if(!(mp.getMotherName().equals("")||mp.getMmotherName().equals("")||mp.getMfatherName().equals("")||
                fp.getFatherName().equals("")||fp.getFfatherName().equals("")||fp.getFmotherName().equals(""))){
            //Igen ronda megoldas, de jelenleg probalok bela resze helyett irni egy mukodot...
            //Egyebkent beallitja a rokoni viszonyokat a felmenoknel, remelem megmaradnak...
            scheduler.getModel().getLegator().getMother().setName(mp.getMotherName());
            scheduler.getModel().getLegator().setParent(scheduler.getModel().getLegator().getMother());
            //scheduler.getModel().getLegator().getMother().addChild(scheduler.getModel().getLegator());
            //scheduler.getModel().getLegator().getMother().increaseChildrenCounter();
            
            scheduler.getModel().getLegator().getMmother().setName(mp.getMmotherName());
            scheduler.getModel().getLegator().getMother().setParent(scheduler.getModel().getLegator().getMmother());
            scheduler.getModel().getLegator().getMmother().addChild(scheduler.getModel().getLegator().getMother());
            //scheduler.getModel().getLegator().getMmother().increaseChildrenCounter();
            
            scheduler.getModel().getLegator().getMfather().setName(mp.getMfatherName());
            scheduler.getModel().getLegator().getMother().setParent(scheduler.getModel().getLegator().getMfather());
            scheduler.getModel().getLegator().getMfather().addChild(scheduler.getModel().getLegator().getMother());
            //scheduler.getModel().getLegator().getMfather().increaseChildrenCounter();
            
            scheduler.getModel().getLegator().getFather().setName(fp.getFatherName());
            scheduler.getModel().getLegator().setParent(scheduler.getModel().getLegator().getFather());
            //scheduler.getModel().getLegator().getFather().addChild(scheduler.getModel().getLegator());
            //scheduler.getModel().getLegator().getFather().increaseChildrenCounter();
            
            scheduler.getModel().getLegator().getFmother().setName(fp.getFmotherName());
            scheduler.getModel().getLegator().getFather().setParent(scheduler.getModel().getLegator().getFmother());
            scheduler.getModel().getLegator().getFmother().addChild(scheduler.getModel().getLegator().getFather());
            //scheduler.getModel().getLegator().getFmother().increaseChildrenCounter();
            
            scheduler.getModel().getLegator().getFfather().setName(fp.getFfatherName());
            scheduler.getModel().getLegator().getFather().setParent(scheduler.getModel().getLegator().getFfather());
            scheduler.getModel().getLegator().getFfather().addChild(scheduler.getModel().getLegator().getFather());
            //scheduler.getModel().getLegator().getFfather().increaseChildrenCounter();
            
            if (lp.getLineageProperties()!=null){
                scheduler.getModel().getLegator().setLineageProperties(lp.getLineageProperties());
            }
            scheduler.windowClosed2();
            this.dispose();
        }
    }
    
    }//GEN-LAST:event_NextActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new LegatorForm().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Commit;
    private javax.swing.JLabel LegatorFormLabel1;
    private javax.swing.JLabel LegatorFormLabel2;
    private javax.swing.JSeparator LegatorFormSeparator2;
    private javax.swing.JTextField NameField;
    private javax.swing.JButton Next;
    private javax.swing.JTabbedPane Panel;
    private javax.swing.JTextField WealthField;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
    
}
