/*
 * PropertyPanel.java
 *
 * Created on 2007. május 23., 14:55
 */

package Successio;

//import java.util.Properties;
import java.util.Vector;
//import javax.swing.DefaultComboBoxModel;
import javax.swing.table.DefaultTableModel;
//import pocv2.*;

/**
 * A felmenoktol orokolt vagyonok bekeresere szolgalo Panel
 * @author  Tar Peter
 */
public class LineagePropertyPanel extends javax.swing.JPanel {
    
    private DefaultTableModel propertyTableModel;
    private Sch scheduler;
    private Property prop;
    private Heir[] parent;
    private Vector<LineageProperty> lineageProperties;
    private LineageProperty property;

    
    public LineagePropertyPanel(Sch scheduler) {
        initComponents();
        this.scheduler = scheduler;
        propertyTableModel=new DefaultTableModel(new Object [][] {},new String [] {"Name", "Price", "From"}) {
            Class[] types = new Class [] {java.lang.String.class, java.lang.Double.class, java.lang.String.class};
            boolean[] canEdit = new boolean [] {false, false, false};
            public Class getColumnClass(int columnIndex) {return types [columnIndex];}
            public boolean isCellEditable(int rowIndex, int columnIndex) {return canEdit [columnIndex];}
        };
        PropertyTable.setRowSelectionAllowed(true);
        PropertyTable.setCellSelectionEnabled(false);
        PropertyTable.setModel(propertyTableModel);
        PropertyTable.getColumnModel().getColumn(0).setPreferredWidth(100);
        PropertyTable.getColumnModel().getColumn(1).setPreferredWidth(60);
        PropertyTable.getColumnModel().getColumn(2).setPreferredWidth(40);       
        
    }
    
    //A panel minden elemet engedelyezni/letiltja
    public void setAllEnabled(boolean b){
        NameField.setEnabled(b);
        PriceField.setEnabled(b);
        Add.setEnabled(b);
        Remove.setEnabled(b);
        PropertyTable.setEnabled(b);
    }
    //visszaadja a felmenoktol orokolt vagyonok vektorat
    public Vector<LineageProperty> getLineageProperties(){
        lineageProperties=new Vector<LineageProperty>();
        if(propertyTableModel.getRowCount()>0){
            Vector propertyVector=propertyTableModel.getDataVector();
            for(int i=0;i<propertyVector.size();i++){
                property=new LineageProperty((String)((Vector)propertyVector.elementAt(i)).elementAt(0),
                        (Double)((Vector)propertyVector.elementAt(i)).elementAt(1),
                        (String)((Vector)propertyVector.elementAt(i)).elementAt(2));
                lineageProperties.add(property);
                }
            parseProperties(lineageProperties);
            return lineageProperties;
        }
        else return null;
    }
    
    public void parseProperties(Vector<LineageProperty> lineageProperties){
        for(LineageProperty lp : lineageProperties){
            if(lp.getLineage().equals("Apa"))
                lp.setLineage(scheduler.getModel().getLegator().getFather().getID());
            else if(lp.getLineage().equals("Apai nagyapa"))
                lp.setLineage(scheduler.getModel().getLegator().getFfather().getID());
            else if(lp.getLineage().equals("Apai nagyanya"))
                lp.setLineage(scheduler.getModel().getLegator().getFmother().getID());
            else if(lp.getLineage().equals("Anya"))
                lp.setLineage(scheduler.getModel().getLegator().getMother().getID());
            else if(lp.getLineage().equals("Anyai nagyapa"))
                lp.setLineage(scheduler.getModel().getLegator().getMfather().getID());
            else if(lp.getLineage().equals("Anyai nagyanya"))
                lp.setLineage(scheduler.getModel().getLegator().getMmother().getID());
        }
    }

    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        PropertyPanelLabel1 = new javax.swing.JLabel();
        PropertyPanelLabel2 = new javax.swing.JLabel();
        PropertyPanelLabel3 = new javax.swing.JLabel();
        NameField = new javax.swing.JTextField();
        PriceField = new javax.swing.JTextField();
        Add = new javax.swing.JButton();
        Remove = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        PropertyTable = new javax.swing.JTable();
        PropertyPaneSeparator = new javax.swing.JSeparator();
        PropertyPanelLabel4 = new javax.swing.JLabel();
        From = new javax.swing.JComboBox();

        addMouseListener(new java.awt.event.MouseAdapter()
        {
            public void mouseClicked(java.awt.event.MouseEvent evt)
            {
                formMouseClicked(evt);
            }
        });

        PropertyPanelLabel1.setText("Felmen\u0151t\u0151l \u00f6r\u00f6k\u00f6lt vagyonok:");

        PropertyPanelLabel2.setText("Vagyon megnevez\u00e9se:");

        PropertyPanelLabel3.setText("Vagyon \u00e9rt\u00e9ke:");

        NameField.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                NameFieldActionPerformed(evt);
            }
        });

        PriceField.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                PriceFieldActionPerformed(evt);
            }
        });

        Add.setText("Hozz\u00e1ad");
        Add.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                AddActionPerformed(evt);
            }
        });

        Remove.setText("Elt\u00e1vol\u00edt");
        Remove.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                RemoveActionPerformed(evt);
            }
        });

        PropertyTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][]
            {

            },
            new String []
            {

            }
        ));
        jScrollPane1.setViewportView(PropertyTable);

        PropertyPanelLabel4.setText("Kit\u0151l kapta:");

        From.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Anya", "Apa", "Anyai nagyanya", "Anyai nagyapa", "Apai nagyanya", "Apai nagyapa" }));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(PropertyPaneSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, 415, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(PropertyPanelLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(NameField, javax.swing.GroupLayout.PREFERRED_SIZE, 223, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(PropertyPanelLabel4)
                                    .addComponent(PropertyPanelLabel3))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(From, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(PriceField, javax.swing.GroupLayout.DEFAULT_SIZE, 223, Short.MAX_VALUE))))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(Add))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 338, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(Remove))
                    .addComponent(PropertyPanelLabel1))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(PropertyPanelLabel2)
                    .addComponent(NameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(PriceField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Add)
                    .addComponent(PropertyPanelLabel3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(PropertyPanelLabel4)
                    .addComponent(From, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(7, 7, 7)
                .addComponent(PropertyPaneSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(PropertyPanelLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 78, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Remove))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

private void formMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseClicked
    // TODO add your handling code here:
    String [] keys={"gi rkls, gi vagyon"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_formMouseClicked

    private void RemoveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RemoveActionPerformed
    //Torli a kijelolt sorokat
    int [] del=PropertyTable.getSelectedRows();
    for(int i=0;i<del.length;i++){
        propertyTableModel.removeRow(del[del.length-1-i]);
    }
    
    }//GEN-LAST:event_RemoveActionPerformed

    private void PriceFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_PriceFieldActionPerformed
    //Meghivja AddActiont
    AddActionPerformed(evt);
    }//GEN-LAST:event_PriceFieldActionPerformed

    private void NameFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NameFieldActionPerformed
    //Meghivja AddActiont
    AddActionPerformed(evt);
    }//GEN-LAST:event_NameFieldActionPerformed

    private void AddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AddActionPerformed
    //Ellenorzi, hogy a beir ertekek helyesek-e, majd hozzaadja a vagyont
    boolean valid=true;
    try{
        double i=Double.parseDouble(PriceField.getText());
    }
    catch(NumberFormatException ex){
        valid=false;
    }
    if(valid){
        propertyTableModel.addRow(new Object[]{NameField.getText(),Double.parseDouble(PriceField.getText()),From.getSelectedItem().toString()});
        NameField.setText("");
        PriceField.setText("0");
    }
    }//GEN-LAST:event_AddActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Add;
    private javax.swing.JComboBox From;
    private javax.swing.JTextField NameField;
    private javax.swing.JTextField PriceField;
    private javax.swing.JSeparator PropertyPaneSeparator;
    private javax.swing.JLabel PropertyPanelLabel1;
    private javax.swing.JLabel PropertyPanelLabel2;
    private javax.swing.JLabel PropertyPanelLabel3;
    private javax.swing.JLabel PropertyPanelLabel4;
    private javax.swing.JTable PropertyTable;
    private javax.swing.JButton Remove;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
    
}
