/*
 * Person.java
 *
 * Created on May 9, 2007, 10:47 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Successio;

import java.util.List;
import java.util.Vector;

/**
 * Szemely osztaly, altalanos tulajdonsagokkal
 * @author Tar Peter
 */
public class Person
{    
    protected boolean dead; //Az illeto halott voltat jelzo valtozo
    protected String name; //Az ember neve
    protected Vector <Person> children; //Az illeto gyerekei egy vektorba tarolva
    protected double weight; //Az illeto sulya, ennyivel szorozzuk a vagyont
    protected String id; //Egyedi azonosito
    protected Vector <Person> parents;
    protected int childrenCounter = 0; // Tarolja hogy hany olyan gyerek van, aki orokolhet
    protected String inherit = ""; // Taroljuk ha nem orokolhet, akkor mi az oka -> kiiratashoz kell
        
    /** Creates a new instance of Person */
    public Person (String name, String id){
        this.name=name;
        dead=false;
        children=new Vector();
        parents=new Vector();
        this.weight = 1.0;
        this.id = id;
    }
    
    //Get, Set, Add, Is fuggvenyek
    public void setName(String name){
        this.name=name;
    }
    
    public String getName(){
        return name;
    }

    public void addChild(Person child){
        children.add(child);
    }
    
    public Person[] getChildren(){
        return children.toArray(new Person[0]);
    }
    
    public void setDead(boolean dead){
        this.dead=dead;
    }
    public boolean isDead(){
        return dead;
    }
    
    public void setWeight(double weight)
    {
        this.weight = weight;
    }
    
    public double getWeight()
    {
        return this.weight;
    }
    
    public String getID()
    {
        return this.id;
    }
    
    public void setParent(Person p)
    {
        parents.add(p);
    }
    
    public Person getParent()
    {
        if(parents.size()!=0)
            return parents.get(0);
        else
            return null;
    }
    
    public Person getParent(int i)
    {
        return parents.get(i);
    }
    
    public boolean hasParent()
    {
        if(parents.size()==0)
            return false;
        else
            return true;
    }
    
    public void increaseChildrenCounter()
    {
        this.childrenCounter++;
    }
    
    public void decreaseChildrenCounter()
    {
        this.childrenCounter--;
    }
    
    public int getChildrenCounter()
    {
        return this.childrenCounter;
    }

    public void resetChildrenCounter()
    {
        childrenCounter=children.size();
    }
}

