/*
 * PropertyPanel.java
 *
 * Created on 2007. majus 23., 14:55
 */

package Successio;

import java.util.Vector;
import javax.swing.table.DefaultTableModel;

/**
 * Az osztalyra bocsatas bekeresere szolgalo Panel
 * @author  Tar Peter
 */
public class PropertyPanel extends javax.swing.JPanel {
    
    private DefaultTableModel propertyTableModel;
    private Sch scheduler;
    
    /**
     * Creates new form PropertyPanel
     */
    public PropertyPanel(Sch scheduler) {
        this.scheduler=scheduler;
        
        initComponents();
        propertyTableModel=new DefaultTableModel(new Object [][] {},new String [] {"N\u00E9v", "\u00C1r"}) {
            Class[] types = new Class [] {java.lang.String.class, java.lang.Double.class};
            boolean[] canEdit = new boolean [] {false, false};
            public Class getColumnClass(int columnIndex) {return types [columnIndex];}
            public boolean isCellEditable(int rowIndex, int columnIndex) {return canEdit [columnIndex];}
        };
        PropertyTable.setRowSelectionAllowed(true);
        PropertyTable.setCellSelectionEnabled(false);
        PropertyTable.setModel(propertyTableModel);
        PropertyTable.getColumnModel().getColumn(0).setPreferredWidth(140);
        PropertyTable.getColumnModel().getColumn(1).setPreferredWidth(60);
    }
    
    //A panel minden elemet engedelyezni/letiltja
    public void setAllEnabled(boolean b){
        NameField.setEnabled(b);
        PriceField.setEnabled(b);
        Add.setEnabled(b);
        Remove.setEnabled(b);
        PropertyTable.setEnabled(b);
    }
    
    //Visszaadja a beadott vagyontargyakat egy tombben
    public Property[] getProperties(){
        if(propertyTableModel.getRowCount()>0){
            Vector propertyVector=propertyTableModel.getDataVector();
            Property[] properties=new Property[propertyVector.size()];
            for(int i=0;i<propertyVector.size();i++){
                properties[i]=new Property( (String)((Vector)propertyVector.elementAt(i)).elementAt(0),
                        (Double)((Vector)propertyVector.elementAt(i)).elementAt(1));
            }
            return properties;
        }
        else
            return null;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        PropertyPanelLabel1 = new javax.swing.JLabel();
        PropertyPanelLabel2 = new javax.swing.JLabel();
        PropertyPanelLabel3 = new javax.swing.JLabel();
        NameField = new javax.swing.JTextField();
        PriceField = new javax.swing.JTextField();
        Add = new javax.swing.JButton();
        Remove = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        PropertyTable = new javax.swing.JTable();
        PropertyPaneSeparator = new javax.swing.JSeparator();

        addMouseListener(new java.awt.event.MouseAdapter()
        {
            public void mouseClicked(java.awt.event.MouseEvent evt)
            {
                formMouseClicked(evt);
            }
        });

        PropertyPanelLabel1.setText("Oszt\u00e1lyrabocs\u00e1tott vagyonok:");

        PropertyPanelLabel2.setText("Vagyon megnevez\u00e9se:");

        PropertyPanelLabel3.setText("Vagyon \u00e9rt\u00e9ke:");

        NameField.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                NameFieldActionPerformed(evt);
            }
        });

        PriceField.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                PriceFieldActionPerformed(evt);
            }
        });

        Add.setText("Hozz\u00e1ad");
        Add.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                AddActionPerformed(evt);
            }
        });

        Remove.setText("Elt\u00e1vol\u00edt");
        Remove.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                RemoveActionPerformed(evt);
            }
        });

        jScrollPane1.addMouseListener(new java.awt.event.MouseAdapter()
        {
            public void mouseClicked(java.awt.event.MouseEvent evt)
            {
                jScrollPane1MouseClicked(evt);
            }
        });

        PropertyTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][]
            {

            },
            new String []
            {

            }
        ));
        jScrollPane1.setViewportView(PropertyTable);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(PropertyPaneSeparator, javax.swing.GroupLayout.DEFAULT_SIZE, 544, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 453, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(Remove))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(PropertyPanelLabel3)
                                    .addComponent(PropertyPanelLabel2))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(NameField, javax.swing.GroupLayout.DEFAULT_SIZE, 302, Short.MAX_VALUE)
                                    .addComponent(PriceField, javax.swing.GroupLayout.DEFAULT_SIZE, 302, Short.MAX_VALUE)))
                            .addComponent(PropertyPanelLabel1, javax.swing.GroupLayout.Alignment.LEADING))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(Add)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(PropertyPanelLabel2)
                    .addComponent(NameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(Add)
                    .addComponent(PropertyPanelLabel3)
                    .addComponent(PriceField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(PropertyPaneSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(8, 8, 8)
                        .addComponent(PropertyPanelLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 208, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED))
                    .addGroup(layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 204, Short.MAX_VALUE)
                        .addComponent(Remove)))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

private void jScrollPane1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jScrollPane1MouseClicked
    // TODO add your handling code here:
    String [] keys={"Hagyatk"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_jScrollPane1MouseClicked

private void formMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseClicked
    // TODO add your handling code here:
    String [] keys={"Hagyatk"};
    scheduler.makeContextMenu (keys, evt);
}//GEN-LAST:event_formMouseClicked

    private void RemoveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RemoveActionPerformed
    //Torli a kijelolt sorokat
    int [] del=PropertyTable.getSelectedRows();
    for(int i=0;i<del.length;i++){
        propertyTableModel.removeRow(del[del.length-1-i]);
    }
    }//GEN-LAST:event_RemoveActionPerformed

    private void PriceFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_PriceFieldActionPerformed
    //Meghivja AddActiont
    AddActionPerformed(evt);
    }//GEN-LAST:event_PriceFieldActionPerformed

    private void NameFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NameFieldActionPerformed
    //Meghivja AddActiont
    AddActionPerformed(evt);
    }//GEN-LAST:event_NameFieldActionPerformed

    private void AddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AddActionPerformed
    //Ellenorzi, hogy a beir ertekek helyesek-e, majd hozzaadja a vagyont
    boolean valid=true;
    try{
        double i=Double.parseDouble(PriceField.getText());
    }
    catch(NumberFormatException ex){
        valid=false;
    }
    if(valid){
        propertyTableModel.addRow(new Object[]{NameField.getText(),Double.parseDouble(PriceField.getText())});
        NameField.setText("");
        PriceField.setText("0");
    }
    }//GEN-LAST:event_AddActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Add;
    private javax.swing.JTextField NameField;
    private javax.swing.JTextField PriceField;
    private javax.swing.JSeparator PropertyPaneSeparator;
    private javax.swing.JLabel PropertyPanelLabel1;
    private javax.swing.JLabel PropertyPanelLabel2;
    private javax.swing.JLabel PropertyPanelLabel3;
    private javax.swing.JTable PropertyTable;
    private javax.swing.JButton Remove;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
    
}
