/*
 * Sch.java
 *
 * Created on 2007. majus 23., 13:21
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Successio;

import java.io.IOException;
import java.util.LinkedList;
import java.util.NoSuchElementException;
import java.util.Vector;
import javax.swing.DefaultListModel;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.xml.stream.XMLStreamException;
import org.xml.sax.SAXException;

/**
 * Utemezo, mely vezerli a programot, kezeli a formokat, es az adatbazist
 * @author Tar Peter
 */
public class Sch {
    
    private Help help; //Help ablak
    private Model model;
    private LinkedList<Heir> formList;
    private Heir somebody, currentPerson;
    private double sum; //Az osszes elosztando vagyon, osztalyra bocsatottakkal egyutt
    boolean addf=false, addm=false, addff=false, addfm=false, addmf=false, addmm=false;
    
    /** Creates a new instance of Sch */
    public Sch() {
        help=new Help(); //uj help ablak letrehozasa
        help.setVisible (false); //help ablak elrjtese egyenlore
        model=new Model();
        formList=new LinkedList();
        new StartingFrame(this);
    }
    
    public void startProgram(){
        new LegatorForm(this,true);
    }
    
    //Get, Set fuggvenyek
    public void setModel(Model model) {
        this.model = model;
    }

    public Model getModel() {
        return model;
    }
    
    //Az orokhagyo adatainak eltarolasa
    public void setLegator(String name, double wealth, String[] names){
        Heir temp=model.getLegator().getWife();
        boolean tempnowife=model.getLegator().isNoWife();
        model.setLegator(new Legator(name));
        model.getLegator().setWife(temp);
        model.getLegator().setNoWife(tempnowife);
        model.getLegator().setWealth(wealth);
        this.sum = wealth;
        if (names!=null){
            for(int i=0;i<names.length;i++){
                if(i < 10)
                    somebody=new Heir(names[i], model.getLegator().getID()+"0"+String.valueOf(i));
                else
                    somebody=new Heir(names[i], model.getLegator().getID()+String.valueOf(i));
                somebody.setParent(model.getLegator());
                formList.add(somebody);
                model.addHeir(somebody);
                model.getLegator().addChild(somebody);
                model.getLegator().increaseChildrenCounter();
            }
        }
    }
    
    //Egy orokos adatainak eltarolasa
    public void setHeir(Property[] properties,String[] names){
        if(model.getHeir(currentPerson.getID()).canInherit()){
            if(properties!=null){
                for(int i=0;i<properties.length;i++){
                    model.getHeir(currentPerson.getID()).addProperty(properties[i]);
                    model.getHeir(currentPerson.getID()).setPropSum(properties[i].getPrice());
                    sum += properties[i].getPrice();
                }
            }
        }
        else{  
            if(names!=null){
                for(int i=0;i<names.length;i++){
                    if(i < 10)
                        somebody=new Heir(names[names.length-1-i], currentPerson.getID()+"0"+String.valueOf(i));
                    else
                        somebody=new Heir(names[names.length-1-i], currentPerson.getID()+String.valueOf(i));
                    somebody.setParent(currentPerson);
                    formList.push(somebody);
                    model.addHeir(somebody);
                    model.getHeir(currentPerson.getID()).addChild(somebody);
                    model.getHeir(currentPerson.getID()).increaseChildrenCounter();
                }
            }
        }
        model.getHeir(currentPerson.getID()).setInherit();
    }
    
    // Beellitja a sulyokat
    public void setWeights() 
    {
        Heir[] heirs = this.model.getHeirs();
        /* Kiveszi a szamitasbol azokat, akik nem orokolhetnek, valamint egyetlen 
         * gyerekuk sem orokolhet. (ha nincs gyerekuk, az is benne van) 
         * Tehat a fa "kihalt" agait szedi le.
         */
        for (int i = 0; i < heirs.length; i++)
        {
            if((!heirs[i].canInherit()) && (!heirs[i].isDone()))
            {
                Heir[] children = (Heir[])heirs[i].getChildren();
                boolean flag = true;
                for (int j = 0; j < children.length; j++)
                {
                    if((children[j].canInherit()) && (!children[j].isDone())) // 2. feltetel az osztalyra bocsatashoz kell
                        flag = false;
                }
                if(flag)
                {
                    this.model.getHeir(heirs[i].getID()).setWeight(0.0);
                    this.model.getHeir(heirs[i].getID()).setDone(true);
                    if(model.getHeir(heirs[i].getID()).getParent()!=null && model.getHeir(heirs[i].getID()).getParent().childrenCounter > 0)
                    	this.model.getHeir(heirs[i].getID()).getParent().decreaseChildrenCounter();
                    heirs[i].setDone(true);
                }
            }
        }
        
        // Akiknel nem vegeztunk, beallitjuk a sulyokat
        for (int i = 0; i < heirs.length; i++)
        {
            if(!heirs[i].isDone())
            {
                if(model.getHeir(heirs[i].getID()).getParent()!=null){
                model.getHeir(heirs[i].getID()).setWeight(
                        model.getHeir(heirs[i].getID()).getParent().getWeight() / 
                        model.getHeir(heirs[i].getID()).getParent().getChildrenCounter());
                }
            }
        }
        
        // Akinel meg nem vegeztunk, es nem orokolhet, beallitjuk az orokseget 0-ra
        for (int i = 0; i < heirs.length; i++)
        {
            if((!heirs[i].isDone()) && (!heirs[i].canInherit()))
            {
                model.getHeir(heirs[i].getID()).setAssets(0.0);
            }
        }
    }


    /* Azok kozul, akik kaptak adomanyt, megnezi hogy az adomany merteke meghaladja-e
     * az orokseget. Ha igen, beallitja a sulyat 0-ra, es kiveszi a szamitasbol.
    */
    public boolean setProperties()
    {
        Heir[] heirs = this.model.getHeirs();
        boolean toReturn = false;
        
        for (int i = 0; i < heirs.length; i++)
        {
            if((heirs[i].getPropSum() != 0.0) && (!heirs[i].isDone()))
            {
                if(model.getHeir(heirs[i].getID()).getWeight() * this.sum <= heirs[i].getPropSum())
                {
                    toReturn = true;
                    model.getHeir(heirs[i].getID()).setWeight(0.0);
                    model.getHeir(heirs[i].getID()).setDone(true);
                    this.model.getHeir(heirs[i].getID()).getParent().decreaseChildrenCounter();
                    this.sum -= heirs[i].getPropSum();
                }
            }
        }
        
        return toReturn;
    }
    
    // Beallitja hogy ki mennyit orokol
    public void setAssets()
    {
        Heir[] heirs = this.model.getHeirs();
        
        for (int i = 0; i < heirs.length; i++)
        {
            if(heirs[i].getAssets() != 0.0)
            {
                if((heirs[i].getPropSum() == 0.0) || (heirs[i].getWeight() == 0.0))
                    model.getHeir(heirs[i].getID()).setAssets(model.getHeir(heirs[i].getID()).getWeight() * this.sum);
                else
                    model.getHeir(heirs[i].getID()).setAssets(model.getHeir(heirs[i].getID()).getWeight() * this.sum - 
                                                              model.getHeir(heirs[i].getID()).getPropSum());
            }
        }
    }
      
    public void setWife(String name)
    {
        this.model.getLegator().getWife().setName(name);
        this.model.getLegator().getWife().setAssets(this.model.getLegator().getWealth());
    }
    
       //Ujrainicializalja a szamolashoz hasznalt addatokat
    private void restart(){
        Heir[] heirs = model.getHeirs();
        for(int i=0;i<heirs.length;i++){
            model.getHeir(heirs[i].getID()).setDone(false);
            model.getHeir(heirs[i].getID()).setWeight(1);
            model.getHeir(heirs[i].getID()).setAssets(1);
            model.getHeir(heirs[i].getID()).resetChildrenCounter();
        }
        model.getLegator().resetChildrenCounter();
    }
    
    // A megvaltasi funkciot megvalosito fuggveny
    public void ademption(){
        //Ha nem agi orokles van
        if(!addf){
            model.getLegator().getWife().setWifeInherit("Az zvegyi haszonlvezet megvltsra kerlt.");
            model.getLegator().getWife().setParent(model.getLegator());
            model.getLegator().addChild(model.getLegator().getWife());
            model.getLegator().increaseChildrenCounter();
            model.addHeir(model.getLegator().getWife());

            restart();
            //Kiszamoljuk a sulyokat, az osztalyra bocsatast, majd szetosztjuk a sulyoknak megfeleloen a penzt
            this.setWeights();
            while(this.setProperties())
            {
                this.setWeights();
            }
            this.setAssets();
            //Itt hivodik meg a kiirato
            new PrintForm(model.getHeirs(), this);
        }
    }
    
    // A megvaltasi funkciot megvalosito fuggveny
    public void ademption2(){
        //Ha agi orokles van
        model.getLegator().getWife().setAssets(model.getLegator().getWife().getAssets()+1/3*this.lineagePropertySum());
        model.getLegator().getWife().setWifeInherit("Az zvegyi haszonlvezet megvltsra kerlt.");
        new PrintForm(model.getHeirs(), this);
    }
    
    private Vector<Heir[]> leszarmazok(Vector<Heir[]> h)
    {
        Vector<Heir[]> toReturn = new Vector<Heir[]>();
        for(Heir ch[] : h)
        {
            for(int i = 0; i < ch.length; i++)
            {
                if(ch[i].getChildren().length > 0)
                {
                    toReturn.add(ch[i].getChildren());
                }
            }
        }
        return toReturn;
    }
    
    private Vector<Heir> torvenyesLeszarmazok(Heir h)
    {
        Vector<Heir> toReturn = new Vector<Heir>();
        Vector<Heir[]> children = new Vector<Heir[]>();
        children.add(h.getChildren());
        
        for(Heir ch[] : children)
        {
            for ( int i = 0; i < ch.length; i++)
            {
                if(ch[i].canInherit())
                {
                    toReturn.add(ch[i]);
                }
            }
        }
       
        while(!leszarmazok(children).isEmpty())
        {
            children = leszarmazok(children);
            for(Heir ch[] : children)
            {
                for ( int i = 0; i < ch.length; i++)
                {
                    if(ch[i].canInherit())
                    {
                        toReturn.add(ch[i]);
                    }
                }
            }
        }
        
        return toReturn;
    }
    
    // 0:apa, 1:apaapa, 2:apaanya, 3:anya, 4:anyaapa, 5:anyaanya
    private boolean[] holAzAgiVagyon(Vector<LineageProperty> lpy)
    {
    	boolean[] toReturn = new boolean[6];
    	for(LineageProperty lp: lpy)
    	{
    		if(lp.getLineage().equals("x"))
    			{toReturn[0] = true;}
    		if(lp.getLineage().equals("xx"))
    			{toReturn[1] = true; toReturn[0]=true;}
    		if(lp.getLineage().equals("xy"))
    			{toReturn[2] = true; toReturn[0]=true;}
    		if(lp.getLineage().equals("y"))
    			{toReturn[3] = true;}
    		if(lp.getLineage().equals("yx"))
    			{toReturn[4] = true; toReturn[3] = true;}
    		if(lp.getLineage().equals("yy"))
    			{toReturn[5] = true; toReturn[3] = true;}
    	}
    	return toReturn;
    }

    //A szetoszto fgv
    public void Distributor(Vector<LineageProperty> lProps)
    {
        for(LineageProperty lp : lProps)
        {
            //ha apai nagyszulo
            if(lp.getLineage().equals(model.getLegator().getFfather().getID()) || lp.getLineage().equals(model.getLegator().getFmother().getID()))
            { 
                System.out.println("apai nagyszulo");
                // ha apa kaphatja                        
                if(model.getLegator().getFather().canInherit())
                {
                    System.out.println("apa kaphatja");
                    model.getLegator().getFather().addProperty(new Property(lp.getName(), lp.getPrice()));
                }
                //apa leszarmazoi
                else if(!this.torvenyesLeszarmazok(model.getLegator().getFather()).isEmpty())
                {
                    System.out.println("apa leszarmazoi");
                    model.getLegator().getFather().setWeight(1.0);
                    model.getLegator().getFather().setDone(true);
                    this.setWeights();
                    for(Heir h : this.torvenyesLeszarmazok(model.getLegator().getFather()))
                    {
                        h.addProperty(new Property(lp.getName(), lp.getPrice()*h.getWeight()));
                    }
                }
                // ha megkaphatja a nagyszulo
                else if(model.getHeir(lp.getLineage()).canInherit())
                {
                    System.out.println("apai nagyszulo kaphatja");
                    model.getHeir(lp.getLineage()).addProperty(new Property(lp.getName(), lp.getPrice()));
                }
                // nagyszulo leszarmazottai
                else if(!this.torvenyesLeszarmazok(model.getHeir(lp.getLineage())).isEmpty())
                {
                    System.out.println("apai nagyszulo leszarmazoi");
                    model.getHeir(lp.getLineage()).setWeight(1.0);
                    model.getHeir(lp.getLineage()).setDone(true);
                    this.setWeights();
                    for(Heir h : this.torvenyesLeszarmazok(model.getHeir(lp.getLineage())))
                    {
                        h.addProperty(new Property(lp.getName(), lp.getPrice()*h.getWeight()));
                    }
                    model.getHeir(lp.getLineage()).setWeight(0.0);
                    model.getHeir(lp.getLineage()).setDone(false);
                }
                // megy a kzsbe
                else
                {
                    this.sum += lp.getPrice();
                }
            }
            
            //ha anyai nagyszulo
            if(lp.getLineage().equals(model.getLegator().getMfather().getID()) || lp.getLineage().equals(model.getLegator().getMmother().getID()))
            { 
                System.out.println("anyai nagyszulo");
                // ha anya kaphatja                        
                if(model.getLegator().getMother().canInherit())
                {
                    System.out.println("anya kaphatja");
                    model.getLegator().getMother().addProperty(new Property(lp.getName(), lp.getPrice()));
                }
                //anya leszarmazoi
                else if(!this.torvenyesLeszarmazok(model.getLegator().getMother()).isEmpty())
                {
                    System.out.println("anya leszarmazoi");
                    model.getLegator().getMother().setWeight(1.0);
                    model.getLegator().getMother().setDone(true);
                    this.setWeights();
                    for(Heir h : this.torvenyesLeszarmazok(model.getLegator().getMother()))
                    {
                        h.addProperty(new Property(lp.getName(), lp.getPrice()*h.getWeight()));
                    }
                    model.getLegator().getMother().setWeight(0.0);
                    model.getLegator().getMother().setDone(false);
                }
                // ha megkaphatja a nagyszulo
                else if(model.getHeir(lp.getLineage()).canInherit())
                {
                    System.out.println("anyai nagyszulo kaphatja");
                    model.getHeir(lp.getLineage()).addProperty(new Property(lp.getName(), lp.getPrice()));
                }
                // nagyszulo leszarmazottai
                else if(!this.torvenyesLeszarmazok(model.getHeir(lp.getLineage())).isEmpty())
                {
                    System.out.println("anyai nagyszulo leszarmazoi");
                    model.getHeir(lp.getLineage()).setWeight(1.0);
                    model.getHeir(lp.getLineage()).setDone(true);
                    this.setWeights();
                    for(Heir h : this.torvenyesLeszarmazok(model.getHeir(lp.getLineage())))
                    {
                        h.addProperty(new Property(lp.getName(), lp.getPrice()*h.getWeight()));
                    }
                    model.getHeir(lp.getLineage()).setWeight(0.0);
                    model.getHeir(lp.getLineage()).setDone(false);
                }
                // megy a kzsbe
                else
                {
                    this.sum += lp.getPrice();
                }
            }
            
            //ha apa
            if(lp.getLineage().equals(model.getLegator().getFather().getID()))
            { 
                System.out.println("apa");
                // ha apa kaphatja                        
                if(model.getLegator().getFather().canInherit())
                {
                    System.out.println("anya kaphatja");
                    model.getLegator().getFather().addProperty(new Property(lp.getName(), lp.getPrice()));
                }
                //apa leszarmazoi
                else if(!this.torvenyesLeszarmazok(model.getLegator().getFather()).isEmpty())
                {
                    System.out.println("apa leszarmazoi");
                    model.getLegator().getFather().setWeight(1.0);
                    model.getLegator().getFather().setDone(true);
                    this.setWeights();
                    for(Heir h : this.torvenyesLeszarmazok(model.getLegator().getFather()))
                    {
                        h.addProperty(new Property(lp.getName(), lp.getPrice()*h.getWeight()));
                    }
                    model.getLegator().getFather().setWeight(0.0);
                    model.getLegator().getFather().setDone(false);
                }
                // megy a kzsbe
                else
                {
                    this.sum += lp.getPrice();
                }
            }
            
            //ha anya
            if(lp.getLineage().equals(model.getLegator().getMother().getID()))
            { 
                System.out.println("anya");
                // ha anya kaphatja                        
                if(model.getLegator().getMother().canInherit())
                {
                    System.out.println("anya kaphatja");
                    model.getLegator().getMother().addProperty(new Property(lp.getName(), lp.getPrice()));
                }
                //anya leszarmazoi
                else if(!this.torvenyesLeszarmazok(model.getLegator().getMother()).isEmpty())
                {
                    System.out.println("anya leszarmazoi");
                    model.getLegator().getMother().setWeight(1.0);
                    model.getLegator().getMother().setDone(true);
                    this.setWeights();
                    for(Heir h : this.torvenyesLeszarmazok(model.getLegator().getMother()))
                    {
                        h.addProperty(new Property(lp.getName(), lp.getPrice()*h.getWeight()));
                    }
                    model.getLegator().getMother().setWeight(0.0);
                    model.getLegator().getMother().setDone(false);
                }
                // megy a kzsbe
                else
                {
                    this.sum += lp.getPrice();
                }
            }
        }
    }
    
    //Formok bezarasakor hivodik meg
    public void windowClosed(){
        //Amig van olyan ember, akit nem kertunk be, akkor bekerjuk a kovetkezo ilyet
        if(!formList.isEmpty()){
            currentPerson=formList.poll();
            new HeirForm(this,currentPerson.getID(), "heir");
        }
        //Ha mar mindenkit bekertunk
        else
        {
            //Kiszamoljuk a sulyokat, az osztalyra bocsatast, majd szetosztjuk a sulyoknak megfeleloen a penzt
            this.setWeights();
            while(this.setProperties())
            {
                this.setWeights();
            }
            this.setAssets();
            //Megvizsgaljuk, hogy van-e olyan orokos, aki orokol
            Heir[] heirs = model.getHeirs();
            boolean heirExists = false;
            for (int i = 0; i < heirs.length; i++)
                if((heirs[i].getAssets() != 0.0) || (heirs[i].canInherit()))
                    heirExists = true;
            //Ha van orokos, beallitjuk ennek megfeleloen a feleseget
            if(heirExists){
                if(!model.getLegator().isNoWife() && model.getLegator().getWife().canInherit()){
                    model.getLegator().getWife().setWifeInherit("A vagyont az \u00F6zvegy haszon\u00E9lvezete terheli");
                    model.getLegator().getWife().setAssets(0);
                }
                else if (model.getLegator().isNoWife()){
                    model.getLegator().getWife().setWifeInherit("Nincs feles\u00E9g");
                    model.getLegator().getWife().setAssets(0);
                }else{
                    model.getLegator().getWife().setInherit();
                    model.getLegator().getWife().setAssets(0);
                }
                //Mivel a feleseg kulon van tarolva, ezert kesziteni kell egy tombot az osszes orokossel
                //plusz a feleseggel, mert egy orokos tombbel hivhato a kiirato form.
                Heir[] people=new Heir[heirs.length+1];
                people[0]=model.getLegator().getWife();
                for(int i=1;i<people.length;i++){
                    people[i]=heirs[i-1];
                }
                //Itt hivodik meg a kiirato
                new PrintForm(people, this);
            }
            
            //Ha nincs orokos...
            else
            {
                new LegatorForm(this,false);
               // this.model.getLegator().getWife().setAssets(this.model.getLegator().getWealth());
            }
        }
    }
    
    /* Agi orokles
     *Ez a bezaro akkor hajtodik vegre,ha nem voltak gyerekek es agi oroklesre van szukseg
     *a masodik next lenyomasa utan indul el
     *attol fuggoen ossza szet a vagyonokat, hogy van-e feleseg es agi orokles 
     */
    
    public boolean hasLegalHeir(Heir current){
        boolean has=false;
        if(current.canInherit())
            has=true;
        else{
            for(int i=0;i<current.getChildren().length;i++){
                if(current.getChildren()[i].canInherit())
                    has=true;
                else
                    has=hasLegalHeir(current.getChildren()[i]);    
            }
        }
        return has;
    }
    
    
    public void windowClosed2(){
       
        boolean flag = false;;
        //Ha a feleseg orokolhet
        if (model.getLegator().getWife().canInherit() && !model.getLegator().isNoWife()){
            model.getLegator().getWife().setAssets(sum-lineagePropertySum());
            model.getLegator().getFather().setAssets(0);
            model.getLegator().getFfather().setAssets(0);
            model.getLegator().getFmother().setAssets(0);
            model.getLegator().getMother().setAssets(0);
            model.getLegator().getMmother().setAssets(0);
            model.getLegator().getMfather().setAssets(0);
            if(!model.getLegator().getLineageProperties().isEmpty()){
            	
            	boolean[] agiVagyon = holAzAgiVagyon(model.getLegator().getLineageProperties());
            	
                if(!formList.isEmpty()){
                    currentPerson=formList.poll();
                    new HeirForm(this,currentPerson.getID(), "lineageheir");
                }

                //Felmenok hozzaadasai, meg bekeregetesei (igen, tudom, ronda...)
                //A lenyege, hogy vegignezi az egyes szulokrol, nagyszulokrol, hogy bekertuk-e oket, es egyaltalan
                //szukseges-e bekerni oket. A formlist vizsgalata a kiiratas miatt kell,
                //hogy a megfelelo emberek a megfelelo helyen szerpeljenek
                else if(!addf && agiVagyon[0]){
                    formList.push(model.getLegator().getFather());
                    model.addHeir(model.getLegator().getFather());
                    addf=true;
                    windowClosed2();
                }

                else if(!addm && agiVagyon[3]){
                    formList.push(model.getLegator().getMother());
                    model.addHeir(model.getLegator().getMother());
                    addm=true;
                    windowClosed2();
                }

                else if(!addff && agiVagyon[1] && !hasLegalHeir(model.getHeir("x"))){
                    formList.push(model.getLegator().getFfather());
                    model.addHeir(model.getLegator().getFfather());
                    addff=true;
                    windowClosed2();
                }

                else if(!addfm && agiVagyon[2] && !hasLegalHeir(model.getHeir("x"))){
                    formList.push(model.getLegator().getFmother());
                    model.addHeir(model.getLegator().getFmother());
                    addfm=true;
                    windowClosed2();
                }

                else if(!addmf && agiVagyon[4] && !hasLegalHeir(model.getHeir("y"))){
                    formList.push(model.getLegator().getMfather());
                    model.addHeir(model.getLegator().getMfather());
                    addmf=true;
                    windowClosed2();
                }

                else if(!addmm && agiVagyon[5] && !hasLegalHeir(model.getHeir("y"))){
                    formList.push(model.getLegator().getMmother());
                    model.addHeir(model.getLegator().getMmother());
                    addmm=true;
                    windowClosed2();
                }
                else
                {
                    //ide kell a szetosztofuggveny
                    Distributor(model.getLegator().getLineageProperties());
                    model.getLegator().getWife().setWifeInherit("A vagyont az \u00F6zvegy haszon\u00E9lvezete terheli");
                    flag = true;
                }
            }
            
            if(flag)
            {
            	this.setWeights();
                this.setAssets();
                //people inicializalasa a feleseggel, a felmenokkel meg a gyerekekkel
                Heir[] people=new Heir[model.getHeirs().length+1];
                people[0]=model.getLegator().getWife(); 
                for(int i=1;i<people.length;i++){
                    people[i]=model.getHeirs()[i-1];
                }
                new PrintForm(people, this);
            }
            else
            {
            	Heir[] people=new Heir[1];
                people[0]=model.getLegator().getWife();
                new PrintForm(people, this);
            }
        }
        
        else if(!formList.isEmpty()){
            currentPerson=formList.poll();
            new HeirForm(this,currentPerson.getID(), "lineageheir");
        }
        
        //Felmenok hozzaadasai, meg bekeregetesei (igen, tudom, ronda...)
        //A lenyege, hogy vegignezi az egyes szulokrol, nagyszulokrol, hogy bekertuk-e oket, es egyaltalan
        //szukseges-e bekerni oket. A formlist vizsgalata a kiiratas miatt kell,
        //hogy a megfelelo emberek a megfelelo helyen szerpeljenek
        else if(!addf){
            formList.push(model.getLegator().getFather());
            model.addHeir(model.getLegator().getFather());
            addf=true;
            windowClosed2();
        }
        
        else if(!addm){
            formList.push(model.getLegator().getMother());
            model.addHeir(model.getLegator().getMother());
            addm=true;
            windowClosed2();
        }
        
        else if(!addff && !hasLegalHeir(model.getHeir("x"))){
            formList.push(model.getLegator().getFfather());
            model.addHeir(model.getLegator().getFfather());
            addff=true;
            windowClosed2();
        }
        
        else if(!addfm && !hasLegalHeir(model.getHeir("x"))){
            formList.push(model.getLegator().getFmother());
            model.addHeir(model.getLegator().getFmother());
            addfm=true;
            windowClosed2();
        }
        
        else if(!addmf && !hasLegalHeir(model.getHeir("y"))){
            formList.push(model.getLegator().getMfather());
            model.addHeir(model.getLegator().getMfather());
            addmf=true;
            windowClosed2();
        }
        
        else if(!addmm && !hasLegalHeir(model.getHeir("y"))){
            formList.push(model.getLegator().getMmother());
            model.addHeir(model.getLegator().getMmother());
            addmm=true;
            windowClosed2();
        }
        
        //Ha mindenki be van kerve, johet a szamolas
        else {
            //Feleseg lerendezese
            if (model.getLegator().isNoWife()){
                model.getLegator().getWife().setWifeInherit("Nincs feles\u00E9g");
                model.getLegator().getWife().setAssets(0);
            }else{
                model.getLegator().getWife().setInherit();
                model.getLegator().getWife().setAssets(0);
            }
            
            //agi vagyonok rendezese
            if (!model.getLegator().getLineageProperties().isEmpty()){
                this.sum=model.getLegator().getWealth() - lineagePropertySum();
                //ide kell a szetosztofuggveny
                Distributor(model.getLegator().getLineageProperties());
            }
            
            //szulok, es nagyszulok sulyainak rendezese
            if(model.getHeir("x")!=null){
                if(hasLegalHeir(model.getHeir("x")))
                    model.getHeir("x").setWeight(0.5);
                else 
                    model.getHeir("x").setWeight(0);
                model.getHeir("x").setDone(true);
                if(!model.getHeir("x").canInherit())
                    model.getHeir("x").setAssets(0);
            }
            if(model.getHeir("y")!=null){
                if(hasLegalHeir(model.getHeir("y")))
                    model.getHeir("y").setWeight(0.5);
                else 
                    model.getHeir("y").setWeight(0);
                model.getHeir("y").setDone(true);
                if(!model.getHeir("y").canInherit())
                    model.getHeir("y").setAssets(0);
            }
            if(model.getHeir("xx")!=null){
                if(hasLegalHeir(model.getHeir("xx")))
                    model.getHeir("xx").setWeight(0.25);
                else 
                    model.getHeir("xx").setWeight(0);
                model.getHeir("xx").setDone(true);
                if(!model.getHeir("xx").canInherit())
                    model.getHeir("xx").setAssets(0);
            }
            if(model.getHeir("xy")!=null){
                if(hasLegalHeir(model.getHeir("xy")))
                    model.getHeir("xy").setWeight(0.25);
                else 
                    model.getHeir("xy").setWeight(0);
                model.getHeir("xy").setDone(true);
                if(!model.getHeir("xy").canInherit())
                    model.getHeir("xy").setAssets(0);
            }
            if(model.getHeir("yx")!=null){
                if(hasLegalHeir(model.getHeir("yx")))
                    model.getHeir("yx").setWeight(0.25);
                else 
                    model.getHeir("yx").setWeight(0);
                model.getHeir("yx").setDone(true);
                if(!model.getHeir("yx").canInherit())
                    model.getHeir("yx").setAssets(0);
            }
            if(model.getHeir("yy")!=null){
                if(hasLegalHeir(model.getHeir("yy")))
                    model.getHeir("yy").setWeight(0.25);
                else 
                    model.getHeir("yy").setWeight(0);
                model.getHeir("yy").setDone(true);
                if(!model.getHeir("yy").canInherit())
                    model.getHeir("yy").setAssets(0);
            }
            //Ha valamelyik agon nincs meg az egyik nagyszulonek senkije
            if(model.getHeir("xx")!=null && model.getHeir("xx").getWeight()==0)
                model.getHeir("xy").setWeight(model.getHeir("xy").getWeight()*2);
            if(model.getHeir("xy")!=null && model.getHeir("xy").getWeight()==0)
                model.getHeir("xx").setWeight(model.getHeir("xx").getWeight()*2);
            if(model.getHeir("yx")!=null && model.getHeir("yx").getWeight()==0)
                model.getHeir("yy").setWeight(model.getHeir("yy").getWeight()*2);
            if(model.getHeir("yy")!=null && model.getHeir("yy").getWeight()==0)
                model.getHeir("yx").setWeight(model.getHeir("yx").getWeight()*2);
            //Ha valamelyik agon egyaltalan nincs senki
            if(model.getHeir("xx")!=null && model.getHeir("xx").getWeight()==0 && 
                    model.getHeir("xy")!=null && model.getHeir("xy").getWeight()==0){
                model.getHeir("yy").setWeight(model.getHeir("yy").getWeight()*2);
                model.getHeir("yx").setWeight(model.getHeir("yx").getWeight()*2);
            }
            if(model.getHeir("yx")!=null && model.getHeir("yx").getWeight()==0 && 
                    model.getHeir("yy")!=null && model.getHeir("yy").getWeight()==0){
                model.getHeir("xy").setWeight(model.getHeir("xy").getWeight()*2);
                model.getHeir("xx").setWeight(model.getHeir("xx").getWeight()*2);
            }
            
            //Szetosztjuk a sulyokat es beallitjuk az orokseget
            this.setWeights();
            this.setAssets();
            
            //Mivel a feleseg kulon van tarolva, ezert kesziteni kell egy tombot az osszes orokossel
            //plusz a feleseggel, mert egy orokos tombbel hivhato a kiirato form.
            Heir[] people=new Heir[model.getHeirs().length+1];
            people[0]=model.getLegator().getWife();
            for(int i=1;i<people.length;i++){
                people[i]=model.getHeirs()[i-1];
            }
            //Megnezzuk, hogy orokol-e valaki egyaltalan
            boolean heirExists=false;
            for(int i=0;i<people.length;i++)
                if(people[i].getAssets()!=0)
                    heirExists=true;
            //Itt hivodik meg a kiirato
            if(heirExists)
                new PrintForm(people, this);
            else
                new PrintForm("Nincs rks, a teljes vagyon az llam: " + model.getLegator().getWealth());
        }
            
    }
    
    public double lineagePropertySum(){
        double lineageSum=0.0;
        if (!model.getLegator().getLineageProperties().isEmpty()){
            for (int i=0;i<model.getLegator().getLineageProperties().size();i++){
                lineageSum+=model.getLegator().getLineageProperties().elementAt(i).getPrice();
            }
        }
        return lineageSum;
    }
    
     public Help getHelp() //Visszaadja a help ablakot
    {
        return help;
    }
    
    public void makeContextMenu(String [] keys, java.awt.event.MouseEvent evt) //Context menu keszito
    {
        if(evt.getButton ()==evt.BUTTON3)
        {
            JPopupMenu menu=new JPopupMenu();
            JMenuItem [] menuItems = new JMenuItem[keys.length];
            for (int i = 0; i < keys.length; i++)
            {
                menuItems[i]=new JMenuItem("Help: ".concat (keys[i])); 
                menuItems[i].addActionListener (new HelpListener(keys[i],help));
                menu.add (menuItems[i]);
            }
            menu.setLocation (evt.getXOnScreen (),evt.getYOnScreen ());
            menu.setVisible (true);
        }       
    }

}
