
!define PRODUCT_NAME "Successio" 
!define PRODUCT_VERSION "1.0"            
!define PRODUCT_PUBLISHER ""  
!define PRODUCT_WEB_SITE "successio@gmail.com"

SetCompressor /SOLID lzma


!include "MUI.nsh"


!define MUI_ABORTWARNING "Installation is not complete"
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_WELCOMEPAGE_TEXT "Welcome to Scheduler Setup Wizard"

;!define MUI_SPECIALBITMAP "schedule.gif"
;!define MUI_HEADERBITMAP "schedule.gif"

;!define MUI_COMPONENTSPAGE_NODESC

!insertmacro MUI_PAGE_WELCOME

;!insertmacro MUI_PAGE_LICENSE "licence.txt" 

!insertmacro MUI_PAGE_DIRECTORY

;!insertmacro MUI_PAGE_COMPONENTS           

!insertmacro MUI_PAGE_INSTFILES

!insertmacro MUI_PAGE_FINISH     

!insertmacro MUI_LANGUAGE "English"


!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS




; MUI end ------






; The name of the installer
Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"

; The file to write
OutFile "${PRODUCT_NAME}_${PRODUCT_VERSION}_Setup.exe"

; The default installation directory
InstallDir "$PROGRAMFILES\${PRODUCT_NAME}\"

;Show file install details (hide|show|nevershow)
ShowInstDetails show




Section 

  SetOverwrite ifnewer ; overwrite files only if newer.

  SetOutPath "$INSTDIR" ; Set output path to the installation directory.

	
	file "toInstall\Successio.jar"
	
	
	setoutPath "$INSTDIR\lib"
	file toInstall\lib\*.*
   
   	# create the uninstaller

	#writeUninstaller "$INSTDIR\uninstall.exe"
	#createShortCut "$SMPROGRAMS\Successio\Uninstall.lnk" "$INSTDIR\uninstall.exe"
    	
   
    	# create a shortcut named "new shortcut" in the start menu programs directory
    	# point the new shortcut at the program uninstaller
	CreateDirectory "$SMPROGRAMS\Successio"
    	createShortCut "$SMPROGRAMS\Successio\Successio.lnk" "$INSTDIR\Successio.jar"
	CreateShortcut "$SMPROGRAMS\Successio\Uninstall.lnk" "$INSTDIR\uninstall.exe"
    	createShortCut "$DESKTOP\Successio.lnk" "$INSTDIR\Successio.jar"

	; Write the installation path into the registry
	WriteRegStr HKLM SOFTWARE\Scheduler "Install_Dir" "$INSTDIR"

	  ; Write the uninstall keys for Windows
	  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Successio" "DisplayName" "Successio"
	  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Successio" "UninstallString" '"$INSTDIR\uninstall.exe"'
	  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Successio" "NoModify" 1
	  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Successio" "NoRepair" 1
	  WriteUninstaller "uninstall.exe"
	
	

SectionEnd












# uninstaller section start
section "uninstall"

  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Successio"
  DeleteRegKey HKLM SOFTWARE\Successio

 
    # first, delete the uninstaller
    delete "$INSTDIR\uninstall.exe"
   
    # second, remove the link from the start menu
    delete "$SMPROGRAMS\Successio.lnk"

    #delete "$SMPROGRAMS\Successio\uninstall.lnk"
 	delete "$INSTDIR\*"
	delete "$INSTDIR\lib\*.*"
	delete "$DESKTOP\Successio.lnk"
	delete "$INSTDIR\lib" 


  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\Successio\*.*"

  ; Remove directories used
  RMDir "$SMPROGRAMS\Successio"

  RMDir "$INSTDIR\lib"
  RMDir "$INSTDIR"
# uninstaller section end
sectionEnd





#Section -Post
#SectionEnd
 